#include "g_local.h"


qboolean findspawnpoint (edict_t *ent)
{
  vec3_t loc = {0,0,0};
  vec3_t floor;
  int i;
  int j = 0;
  int k = 0;
  int jmax = 1000;
  int kmax = (int)(jmax/2);
  qboolean found = false;
  trace_t tr;
  do {
    if (found || j >= jmax || k >= kmax)
      break;
    j++;
    for (i = 0; i < 3; i++)
      loc[i] = rand() % (8192 + 1) - 4096;//FREDZ was loc[i] = rand() % (8192 + 1) - 4096;
    if (gi.pointcontents(loc) == 0)
    {
        VectorCopy(loc, floor);
//      floor[2] = -4096;//FREDZ was floor[2] = -4096; //FREDZ make it more random
        tr = gi.trace (loc, ent->maxs, ent->mins, floor, NULL, MASK_SOLID|MASK_WATER);
        k++;

/*        if (!ValidBoxAtLoc( ent->s.origin, tv(-16, -16, -24), tv(16, 16, 48), NULL, MASK_PLAYERSOLID|CONTENTS_MONSTERCLIP ))//FREDZ should fix player spot, not working
        {
			if(developer->value)
				gi.dprintf( "WARNING: player spawn in solid at: %i, %i, %i\n", (int)ent->s.origin[0], (int)ent->s.origin[1], (int)ent->s.origin[2] );
            found = false;
        }*/

        if (tr.contents & MASK_WATER)
            found = false;
        else
        {
            VectorCopy (tr.endpos, loc);
            loc[2] += ent->maxs[2] - ent->mins[2]; // make sure the entity can fit!
            found = (gi.pointcontents(loc) == 0 ? true : false);
        }
    }
    else
      found = false;
  } while (!found && j < jmax && k < kmax);
  if (!found && (j >= jmax || k >= kmax))
    return false;
  VectorCopy(loc, ent->s.origin);

  VectorCopy(loc, ent->s.old_origin);
  return true;
}

qboolean spawn_random_item(char *classname)
{

    edict_t     *ent;
    gitem_t     *item;
    static int skin = 0;

    item = FindItemByClassname(classname);
    if (!item)
	{
        gi.dprintf("doesn't exist");
	return 0;
	}

    ent = G_Spawn();

    ent->classname=gi.TagMalloc(64*sizeof(char), TAG_LEVEL);
    strcpy(ent->classname,classname);

    ent->item = item;
    ent->s.effects = ent->item->world_model_flags;
//    ent->s.renderfx = RF_GLOW;//FREDZ no glow
    ent->touch = Touch_Item;

    VectorSet (ent->mins, -15, -15, -15);
    VectorSet (ent->maxs, 15, 15, 15);
//    gi.setmodel (ent, ent->item->world_model);
    ent->solid = SOLID_TRIGGER;
    ent->movetype = MOVETYPE_BOUNCE;//FREDZ maybe should be MOVETYPE_TOSS
    ent->owner = ent;

    //FREDZ egg code
    if (((int)egg_flags->value & EF_TEAM_EGGS) && (teamplay->value))
    {
        gi.setmodel (ent, "models/items/eggteam/eggteam.md2");
       if (skin >= 2)
            skin = 0;
        ent->s.skinnum = skin++;
 //       ent->s.skinnum = ent->style;//Skin color
    }
    else
    {
//      ent->model = "models/items/egg/egg.md2";//FREDZ does not work
        gi.setmodel (ent, "models/items/egg/egg.md2");//fix
        if (skin >= EGG_SKINS)
            skin = 0;
        ent->s.skinnum = skin++;
    }
    //FREDZ end egg code

    while (findspawnpoint(ent) == false){}

    gi.linkentity (ent);
    gi.dprintf("%s Added at %d,%d,%d\n",ent->classname,(int)ent->s.origin[0],(int)ent->s.origin[1],(int)ent->s.origin[2]);
    return 1;
}
qboolean load_random_items(void)
{
    int i, j;
    char	*item;
    #define itemsweaponcount 17
    #define itemsammocount 11
    static char *itemsweapons[itemsweaponcount] =
    {
        "weapon_crowbar",
//        "weapon_spistol",
        "weapon_pistol",
        "weapon_shotgun",
        "weapon_tommygun",
        "weapon_heavymachinegun",
        "weapon_grenadelauncher",
        "weapon_bazooka",
        "weapon_flamethrower",
        "weapon_heavymachinegun_cooling",
        "item_armor_jacket_heavy",
        "item_armor_helmet_heavy",
        "item_armor_legs_heavy",
        "item_armor_jacket",
        "item_armor_helmet",
        "item_armor_legs",
        "item_adrenaline",
        "item_pack"
//        "item_flashlight"
    };
    //FREDZ seprated to spawn more
    static char *itemsammo[itemsammocount] =
    {
        "weapon_pistol_mag",
        "weapon_pistol_rof",
        "ammo_bullets",
        "ammo_shells",
        "ammo_cylinder",
        "ammo_308",
        "ammo_rockets",
        "ammo_grenades",
        "ammo_flametank",
        "item_health_sm",
        "item_health_lg"
    };

//    item = "";
    item = "";


    for (i=0; i<itemsammocount; i++)
    {
        item = itemsammo[i]; // MH: fix
        j = 0;
        while ( j < 4 )
        {
            spawn_random_item(item);
            j++;
        }
    }

    for (i=0; i<itemsweaponcount; i++)
    {
        item = itemsweapons[i]; // MH: fix
        j = 0;
        while ( j < 2 )
        {
            spawn_random_item(item);
            j++;
        }
    }


    return 1;


}




